<template>
    <v-dialog v-model="visible" persistent max-width="400">
        <v-snackbar v-model="snack" top color="blue">Puntaje actualizado</v-snackbar>
        <v-card>
                <v-toolbar class="mb-3">
                    <v-toolbar-title>{{ name }}</v-toolbar-title>
                    <v-spacer></v-spacer>
                    <v-toolbar-items>
						<v-btn text icon color="red" @click="closeForm">
							<v-icon>fas fa-times</v-icon>
						</v-btn>
					</v-toolbar-items>
                </v-toolbar>
            <v-card-text>
                <v-row justify="space-around">
					<v-col cols="12" sm="5">
						<v-text-field label="Valor" :value="valor" v-model="value" outlined type="number" min="0" />
					</v-col>
					<v-col cols="12" sm="5">
						<v-btn :loading="loading" color="green" block outlined @click="updateScore">
							Actualizar
							<template v-slot:loader>
								<span>Actualizando...</span>
							</template>
						</v-btn>
					</v-col>
				</v-row>
            </v-card-text>
        </v-card>
    </v-dialog>
</template>

<script>
import EventBus from "../../bus";
import gql from "graphql-tag";

export default {
    name: "ModalUpdateScoreCareer",
    props:["visible", "institute", "name", "valor"],
    data:() => ({
        loading: false,
        snack: false,
        value:0
    }),
    watch: {
		valor: function(val) {
			this.value = this.valor;
		}
	},
    methods:{
        // actualiza el puntaje
		async updateScore() {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation(
							$value: Int!
							$career: String!
							$institute: String!
						) {
							changeValueCareer(
								value: $value
								career: $career
								institute: $institute
							)
						}
					`,
					variables: {
						value: parseInt(this.value),
						career: this.name,
						institute: this.institute
					}
				});
				this.loading = true;
				setTimeout(() => {
					this.loading = false;
					this.snack = true;
					setTimeout(() => {
                        this.closeForm();
					}, 1500);
				}, 2000);
			} catch (error) {}
		},
        closeForm(){
            EventBus.$emit("closeUpdateScoreCareer", this.institute);
        },
    },
}
</script>